jQuery(document).ready(function($) {

	// Custom popup box
	$("#adstw-style-generator-button").click(function(){
		
		// Reset Animation field
		$("#adstw-example").removeClass();
		$("#adstw-example").addClass("style-col");
		$('#adstw-text-animation').val('none')
		
		// Show Wrappers
		$("#adstw-style-generator-wrap, #adstw-style-generator-overlay").show()
		
	});
	
	$("#adstw-style-generator-close").click(function(){
		$("#adstw-style-generator-wrap, #adstw-style-generator-overlay").hide();
	});
	
	
	// ON LOAD -> Example // 
	
	
	// Font link
	$("#adstw-font-demo-css").attr("href", "http://fonts.googleapis.com/css?family=" + $('#adstw-generator-select-gfont').val() + ":100,100italic,200,200italic,300,300italic,400,400italic,500,500italic,600,600italic,700,700italic,800,800italic,900,900italic" );
	// Font 
	$("#adstw-example").css({ "font-family" : $('#adstw-generator-select-gfont').val() });
	// Size 
	$("#adstw-example").css({ "font-size" : $('#adstw-font-size').val() });
	// Color 
	$("#adstw-example").css({ "color" : $('#adstw-style-color').val() });
	// Weight 
	$("#adstw-example").css({ "font-weight" : $('#adstw-font-weigth').val() });
	// Style 
	$("#adstw-example").css({ "font-style" : $('#adstw-font-style').val() });
	// Line Height 
	$("#adstw-example").css({ "line-height" : $('#adstw-line-height').val() });
	// Text Align 
	$("#adstw-example").css({ "text-align" : $('#adstw-text-align').val() });
	// Text Direction 
	$("#adstw-example").css({ "transform" : $('#adstw-text-direction').val() });
	// Text Animation 
	$("#adstw-example").addClass("animated " + $('#adstw-text-animation').val() );
	
	// ON CHANGE -> Example //
	
	// Font Link
	$('#adstw-generator-select-gfont').change(function() {
		
		var selectedFont = $(this).val();
		
		if (selectedFont !== 'default') {
		$("#adstw-font-demo-css").attr("href", "http://fonts.googleapis.com/css?family=" + selectedFont + ":100,100italic,200,200italic,300,300italic,400,400italic,500,500italic,600,600italic,700,700italic,800,800italic,900,900italic" );
		}	
		
	});
	
	// Font
	$('#adstw-generator-select-gfont').change(function() {
		
		var selectedFont = $(this).val();
		
		if (selectedFont !== 'default') {
		$("#adstw-example").css({ "font-family" : selectedFont });
		}else{
		$("#adstw-example").css({ "font-family" : "inherit" });
		}		
		
	});
	
	// Size
	$('#adstw-font-size').change(function() {
		
		var selectedSize = $(this).val();
		
		if (selectedSize !== '') {
		$("#adstw-example").css({ "font-size" : selectedSize });
		}else{
		$("#adstw-example").css({ "font-size" : "inherit" });
		}		
		
	});
	
	// Color
	$('#adstw-style-color').iris({
    hide: false,
    change: function(event, ui) {
        // change the headline color
        $("#adstw-example").css( 'color', ui.color.toString());
		$(".wp-color-result").css('background', ui.color.toString());
		}
	});
	
	// Weight
	$('#adstw-font-weigth').change(function() {
		
		var selectedWeight = $(this).val();
		
		if (selectedWeight !== '') {
		$("#adstw-example").css({ "font-weight" : selectedWeight });
		}else{
		$("#adstw-example").css({ "font-weight" : "inherit" });
		}		
		
	});
	
	// Style
	$('#adstw-font-style').change(function() {
		
		var selectedStyle = $(this).val();
		
		if (selectedStyle !== '') {
		$("#adstw-example").css({ "font-style" : selectedStyle });
		}else{
		$("#adstw-example").css({ "font-style" : "inherit" });
		}		
		
	});
	
	// Line Height
	$('#adstw-line-height').change(function() {
		
		var selectedHeight = $(this).val();
		
		if (selectedHeight !== '') {
		$("#adstw-example").css({ "line-height" : selectedHeight });
		}else{
		$("#adstw-example").css({ "line-height" : "inherit" });
		}		
		
	});
	
	// Text Align
	$('#adstw-text-align').change(function() {
		
		var selectedAlign = $(this).val();
		
		if (selectedAlign !== '') {
		$("#adstw-example").css({ "text-align" : selectedAlign });
		}else{
		$("#adstw-example").css({ "text-align" : "inherit" });
		}		
		
	});
	
	// Text Direction
	$('#adstw-text-direction').change(function() {
		
		var selectedDirection = $(this).val();
		
		if (selectedDirection !== '') {
		$("#adstw-example").css({ "transform" : selectedDirection });
		}else{
		$("#adstw-example").css({ "transform" : "none" });
		}		
		
	});
	
	// Text Animation
	$('#adstw-text-animation').change(function() {
		
		$("#adstw-example").removeClass();
		$("#adstw-example").addClass("style-col");
		
		var selectedAnimation = $(this).val();
		
		if (selectedAnimation !== 'none') {
		$("#adstw-example").addClass( "animated " + selectedAnimation );
		}	
		
	});
	
	
	// Insert shortcode
	$('#adstw-style-generator-insert').live('click', function(event) {
		
		// Vars 
		var font = $('#adstw-generator-select-gfont').val(),
		size = $('#adstw-font-size').val(),
		color = $('#adstw-style-color').val(),
		weight = $('#adstw-font-weigth').val(),
		style = $('#adstw-font-style').val(),
		lineheight = $('#adstw-line-height').val(),
		align = $('#adstw-text-align').val(),
		direction = $('#adstw-text-direction').val(),
		animation = $('#adstw-text-animation').val(),
		content = $('#adstw-generator-content').val();
		
		var shortcode = '[adstw_style font_name="' + font + '" font_color="' + color + '" font_size="' + size + '" font_weight="' + weight + '" font_style="' + style + '" line_height="' + lineheight + '" text_align="' + align + '" text_direction="' + direction + '" text_animation="' + animation + '"]' + content + '[/adstw_style]';

		// Insert into widget
		if ( typeof window.su_generator_target !== 'undefined' ) {
			$('textarea#' + window.su_generator_target).val( $('textarea#' + window.su_generator_target).val() + shortcode);
			tb_remove();
		}

		// Insert into editor
		else {
			window.send_to_editor(shortcode);
		}
		
		$("#adstw-style-generator-wrap, #adstw-style-generator-overlay").hide();

		// Prevent default action
		event.preventDefault();
		return false;
		
	}); // Insert Shortcode
	

}); // jQuery